import type { LPTokenHook, CalculateAddLiquidityHook, CalculateRemoveLiquidityHook, CalculateRemoveLiquidityOneTokenHook, AddLiquidityHook, RemoveLiquidityHook, RemoveLiquidityOneTokenHook, CalculateSwapRateHook, SwapTokensHook, ApproveLPTokenHook, ApproveTokenForLPHook, LPTokenAllowanceHook, TokenForLPAllowanceHook } from "./types";
/**
 * Returns the Stableswap LP token object for a given Chain ID, if one exists.
 *
 * @param ethereum
 * @param chainId
 *
 * @return Single-item array containing LP token object
 */
declare function useChainStableswapLPToken(ethereum: any, chainId: number): LPTokenHook;
/**
 * Returns the ETHSwap LP token object for a given Chain ID, if one exists.
 *
 * @param ethereum
 * @param chainId
 *
 * @return Single-item array containing LP token object
 */
declare function useChainETHSwapLPToken(ethereum: any, chainId: number): LPTokenHook;
declare function useHarmonyJewelLPToken(ethereum: any, chainId: number): LPTokenHook;
declare function useHarmonyAVAXLPToken(ethereum: any, chainId: number): LPTokenHook;
declare function useCalculateAddLiquidity(ethereum: any, chainId: number): CalculateAddLiquidityHook;
declare function useCalculateRemoveLiquidity(ethereum: any, chainId: number): CalculateRemoveLiquidityHook;
declare function useCalculateRemoveLiquidityOneToken(ethereum: any, chainId: number): CalculateRemoveLiquidityOneTokenHook;
declare function useAddLiquidity(ethereum: any, chainId: number): AddLiquidityHook;
declare function useRemoveLiquidity(ethereum: any, chainId: number): RemoveLiquidityHook;
declare function useRemoveLiquidityOneToken(ethereum: any, chainId: number): RemoveLiquidityOneTokenHook;
declare function useCalculateSwapRate(ethereum: any, chainId: number): CalculateSwapRateHook;
declare function useSwapTokens(ethereum: any, chainId: number): SwapTokensHook;
declare function useApproveLPToken(ethereum: any, chainId: number): ApproveLPTokenHook;
declare function useApproveTokenForLP(ethereum: any, chainId: number): ApproveTokenForLPHook;
declare function useLPTokenAllowance(ethereum: any, chainId: number): LPTokenAllowanceHook;
declare function useTokenForLPAllowance(ethereum: any, chainId: number): TokenForLPAllowanceHook;
export { useChainStableswapLPToken, useChainETHSwapLPToken, useHarmonyJewelLPToken, useHarmonyAVAXLPToken, useCalculateAddLiquidity, useCalculateRemoveLiquidity, useCalculateRemoveLiquidityOneToken, useAddLiquidity, useRemoveLiquidity, useRemoveLiquidityOneToken, useCalculateSwapRate, useSwapTokens, useApproveLPToken, useApproveTokenForLP, useLPTokenAllowance, useTokenForLPAllowance };
