var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { isArray } from "lodash-es";
import { SwapPools } from "../swappools.js";
import { TokenSwap } from "../tokenswap.js";
import { useSignerFromEthereumFn } from "./signer.js";
import { useApproveStatus, useApproveTokenSpend, useCheckAllowance } from "./tokens.js";
import { parseBigNumberish, parseLPTokenBigNumberishArray } from "./helpers.js";
import { useEffect, useState } from "react";
import { BigNumber } from "@ethersproject/bignumber";
/**
 * Returns the Stableswap LP token object for a given Chain ID, if one exists.
 *
 * @param ethereum
 * @param chainId
 *
 * @return Single-item array containing LP token object
 */
function useChainStableswapLPToken(ethereum, chainId) {
    var _a = useState(null), lpToken = _a[0], setLpToken = _a[1];
    useEffect(function () {
        if (typeof chainId !== 'undefined' && chainId !== null) {
            if (lpToken !== null) {
                if (lpToken.chainId !== chainId) {
                    setLpToken(SwapPools.stableswapPoolForNetwork(chainId));
                }
            }
            else {
                setLpToken(SwapPools.stableswapPoolForNetwork(chainId));
            }
        }
    }, [chainId]);
    return [lpToken];
}
/**
 * Returns the ETHSwap LP token object for a given Chain ID, if one exists.
 *
 * @param ethereum
 * @param chainId
 *
 * @return Single-item array containing LP token object
 */
function useChainETHSwapLPToken(ethereum, chainId) {
    var _a = useState(null), lpToken = _a[0], setLpToken = _a[1];
    useEffect(function () {
        if (typeof chainId !== 'undefined' && chainId !== null) {
            if (lpToken !== null) {
                if (lpToken.chainId !== chainId) {
                    setLpToken(SwapPools.ethSwapPoolForNetwork(chainId));
                }
            }
            else {
                setLpToken(SwapPools.ethSwapPoolForNetwork(chainId));
            }
        }
    }, [chainId]);
    return [lpToken];
}
function useHarmonyJewelLPToken(ethereum, chainId) {
    return [SwapPools.HARMONY_JEWEL_SWAP_TOKEN];
}
function useHarmonyAVAXLPToken(ethereum, chainId) {
    return [SwapPools.HARMONY_AVAX_SWAP_TOKEN];
}
function useCalculateAddLiquidity(ethereum, chainId) {
    var _a = useState(null), amount = _a[0], setAmount = _a[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var amountsArray, amts, res, e_1, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (isArray(args.amounts)) {
                            amts = args.amounts;
                            amountsArray = parseLPTokenBigNumberishArray(args.lpToken, amts, chainId);
                        }
                        else {
                            amountsArray = args.lpToken.liquidityAmountsFromMap(args.amounts);
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, TokenSwap.calculateAddLiquidity(__assign(__assign({}, args), { amounts: amountsArray, chainId: chainId }))];
                    case 2:
                        res = _a.sent();
                        setAmount(res);
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        err = e_1 instanceof Error ? e_1 : new Error(e_1);
                        console.error(err);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, amount];
}
function useCalculateRemoveLiquidity(ethereum, chainId) {
    var _a = useState(null), amounts = _a[0], setAmounts = _a[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var res, e_2, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, TokenSwap.calculateRemoveLiquidity(__assign(__assign({}, args), { amount: parseBigNumberish(args.amount, args.lpToken.baseToken, chainId), chainId: chainId }))];
                    case 1:
                        res = _a.sent();
                        setAmounts(res);
                        return [3 /*break*/, 3];
                    case 2:
                        e_2 = _a.sent();
                        err = e_2 instanceof Error ? e_2 : new Error(e_2);
                        console.error(err);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, amounts];
}
function useCalculateRemoveLiquidityOneToken(ethereum, chainId) {
    var _a = useState(null), amount = _a[0], setAmount = _a[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var res, e_3, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, TokenSwap.calculateRemoveLiquidityOneToken(__assign(__assign({}, args), { amount: parseBigNumberish(args.amount, args.token, chainId), chainId: chainId }))];
                    case 1:
                        res = _a.sent();
                        setAmount(res);
                        return [3 /*break*/, 3];
                    case 2:
                        e_3 = _a.sent();
                        err = e_3 instanceof Error ? e_3 : new Error(e_3);
                        console.error(err);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, amount];
}
function useAddLiquidity(ethereum, chainId) {
    var getSigner = useSignerFromEthereumFn()[0];
    var _a = useState(null), tx = _a[0], setTx = _a[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var amountsArray, amts, res, e_4, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (isArray(args.amounts)) {
                            amts = args.amounts;
                            amountsArray = parseLPTokenBigNumberishArray(args.lpToken, amts, chainId);
                        }
                        else {
                            amountsArray = args.lpToken.liquidityAmountsFromMap(args.amounts);
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, TokenSwap.addLiquidity(__assign(__assign({}, args), { deadline: BigNumber.from(args.deadline), amounts: amountsArray, minToMint: parseBigNumberish(args.minToMint, args.lpToken.baseToken, chainId), chainId: chainId, signer: getSigner(ethereum) }))];
                    case 2:
                        res = _a.sent();
                        setTx(res);
                        return [3 /*break*/, 4];
                    case 3:
                        e_4 = _a.sent();
                        err = e_4 instanceof Error ? e_4 : new Error(e_4);
                        console.error(err);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, tx];
}
function useRemoveLiquidity(ethereum, chainId) {
    var getSigner = useSignerFromEthereumFn()[0];
    var _a = useState(null), tx = _a[0], setTx = _a[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var minAmountsArray, amts, res, e_5, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (isArray(args.minAmounts)) {
                            amts = args.minAmounts;
                            minAmountsArray = parseLPTokenBigNumberishArray(args.lpToken, amts, chainId);
                        }
                        else {
                            minAmountsArray = args.lpToken.liquidityAmountsFromMap(args.minAmounts);
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, TokenSwap.removeLiquidity(__assign(__assign({}, args), { deadline: BigNumber.from(args.deadline), amount: parseBigNumberish(args.amount, args.lpToken.baseToken, chainId), minAmounts: minAmountsArray, chainId: chainId, signer: getSigner(ethereum) }))];
                    case 2:
                        res = _a.sent();
                        setTx(res);
                        return [3 /*break*/, 4];
                    case 3:
                        e_5 = _a.sent();
                        err = e_5 instanceof Error ? e_5 : new Error(e_5);
                        console.error(err);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, tx];
}
function useRemoveLiquidityOneToken(ethereum, chainId) {
    var getSigner = useSignerFromEthereumFn()[0];
    var _a = useState(null), tx = _a[0], setTx = _a[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var res, e_6, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, TokenSwap.removeLiquidityOneToken(__assign(__assign({}, args), { deadline: BigNumber.from(args.deadline), amount: parseBigNumberish(args.amount, args.token, chainId), minAmount: parseBigNumberish(args.minAmount, args.lpToken.baseToken, chainId), chainId: chainId, signer: getSigner(ethereum) }))];
                    case 1:
                        res = _a.sent();
                        setTx(res);
                        return [3 /*break*/, 3];
                    case 2:
                        e_6 = _a.sent();
                        err = e_6 instanceof Error ? e_6 : new Error(e_6);
                        console.error(err);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, tx];
}
function useCalculateSwapRate(ethereum, chainId) {
    var _a = useState(null), swapRate = _a[0], setSwapRate = _a[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var res, e_7, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, TokenSwap.calculateSwapRate(__assign(__assign({}, args), { amountIn: parseBigNumberish(args.amountIn, args.tokenFrom, chainId), chainId: chainId }))];
                    case 1:
                        res = _a.sent();
                        setSwapRate(res.amountOut);
                        return [3 /*break*/, 3];
                    case 2:
                        e_7 = _a.sent();
                        err = e_7 instanceof Error ? e_7 : new Error(e_7);
                        console.error(err);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, swapRate];
}
function useSwapTokens(ethereum, chainId) {
    var getSigner = useSignerFromEthereumFn()[0];
    var _a = useState(null), tx = _a[0], setTx = _a[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var fnParams, swapTx, e_8, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fnParams = __assign(__assign({}, args), { amountIn: parseBigNumberish(args.amountIn, args.tokenFrom, chainId), minAmountOut: parseBigNumberish(args.minAmountOut, args.tokenTo, chainId), chainId: chainId, signer: getSigner(ethereum) });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, TokenSwap.swapTokens(fnParams)];
                    case 2:
                        swapTx = _a.sent();
                        setTx(swapTx);
                        return [3 /*break*/, 4];
                    case 3:
                        e_8 = _a.sent();
                        err = e_8 instanceof Error ? e_8 : new Error(e_8);
                        console.error(err);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, tx];
}
function useApproveLPToken(ethereum, chainId) {
    var _a = useApproveTokenSpend(ethereum, chainId), approveSpend = _a[0], approveTx = _a[1], _b = useApproveStatus(ethereum, chainId), queryApproveStatus = _b[0], approveStatus = _b[1];
    var _c = useState(null), approveData = _c[0], setApproveData = _c[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var amount, _a, spender, token, e_9, err;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        amount = args.amount, _a = args.lpToken, spender = _a.swapAddress, token = _a.baseToken;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, approveSpend({
                                token: token,
                                spender: spender,
                                amount: amount
                            })];
                    case 2:
                        _b.sent();
                        setApproveData({ token: token, spender: spender, amount: amount });
                        return [3 /*break*/, 4];
                    case 3:
                        e_9 = _b.sent();
                        err = e_9 instanceof Error ? e_9 : new Error(e_9);
                        console.error(err);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    useEffect(function () {
        if (approveTx && approveData && !approveStatus) {
            var token = approveData.token, spender = approveData.spender, amount = approveData.amount;
            queryApproveStatus({
                token: token,
                spender: spender,
                amount: amount,
                approveTx: approveTx
            });
        }
    }, [approveTx, approveData, approveStatus]);
    return [fn, approveTx, approveStatus];
}
function useApproveTokenForLP(ethereum, chainId) {
    var _a = useApproveTokenSpend(ethereum, chainId), approveSpend = _a[0], approveTx = _a[1], _b = useApproveStatus(ethereum, chainId), queryApproveStatus = _b[0], approveStatus = _b[1];
    var _c = useState(null), approveData = _c[0], setApproveData = _c[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var amount, token, spender, e_10, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        amount = args.amount, token = args.token, spender = args.lpToken.swapAddress;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, approveSpend({
                                token: token,
                                spender: spender,
                                amount: amount
                            })];
                    case 2:
                        _a.sent();
                        setApproveData({ token: token, spender: spender, amount: amount });
                        return [3 /*break*/, 4];
                    case 3:
                        e_10 = _a.sent();
                        err = e_10 instanceof Error ? e_10 : new Error(e_10);
                        console.error(err);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    useEffect(function () {
        if (approveTx && approveData && !approveStatus) {
            var token = approveData.token, spender = approveData.spender, amount = approveData.amount;
            queryApproveStatus({
                token: token,
                spender: spender,
                amount: amount,
                approveTx: approveTx
            });
        }
    }, [approveTx, approveData, approveStatus]);
    return [fn, approveTx, approveStatus];
}
function useLPTokenAllowance(ethereum, chainId) {
    var _a = useCheckAllowance(ethereum, chainId), checkAllowance = _a[0], allowance = _a[1];
    function fn(lpToken) {
        return __awaiter(this, void 0, void 0, function () {
            var token, spender, e_11, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        token = lpToken.baseToken, spender = lpToken.swapAddress;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, checkAllowance({ token: token, spender: spender })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_11 = _a.sent();
                        err = e_11 instanceof Error ? e_11 : new Error(e_11);
                        console.error(err);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, allowance];
}
function useTokenForLPAllowance(ethereum, chainId) {
    var _a = useCheckAllowance(ethereum, chainId), checkAllowance = _a[0], allowance = _a[1];
    function fn(args) {
        return __awaiter(this, void 0, void 0, function () {
            var token, spender, e_12, err;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        token = args.token, spender = args.lpToken.swapAddress;
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, checkAllowance({ token: token, spender: spender })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        e_12 = _a.sent();
                        err = e_12 instanceof Error ? e_12 : new Error(e_12);
                        console.error(err);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    }
    return [fn, allowance];
}
export { useChainStableswapLPToken, useChainETHSwapLPToken, useHarmonyJewelLPToken, useHarmonyAVAXLPToken, useCalculateAddLiquidity, useCalculateRemoveLiquidity, useCalculateRemoveLiquidityOneToken, useAddLiquidity, useRemoveLiquidity, useRemoveLiquidityOneToken, useCalculateSwapRate, useSwapTokens, useApproveLPToken, useApproveTokenForLP, useLPTokenAllowance, useTokenForLPAllowance };
