var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s;
import { useWeb3React } from "@web3-react/core";
import { getChainRpcUri } from "../internal/rpcproviders.js";
import { NetworkConnector } from "../internal/rpcconnector.js";
import { ChainId, supportedChainIds } from "../common/chainid.js";
import { InjectedConnector } from "@web3-react/injected-connector";
import { useEffect, useState } from "react";
import { Web3Provider } from "@ethersproject/providers";
export var NETWORK_CONNECTOR = new NetworkConnector({
    defaultChainId: ChainId.ETH,
    urls: (_a = {}, _a[ChainId.ETH] = getChainRpcUri(ChainId.ETH), _a)
});
var CONNECTOR_MAP = (_b = {},
    _b[ChainId.ETH] = new NetworkConnector({
        defaultChainId: ChainId.ETH,
        urls: (_c = {}, _c[ChainId.ETH] = getChainRpcUri(ChainId.ETH), _c)
    }),
    _b[ChainId.OPTIMISM] = new NetworkConnector({
        defaultChainId: ChainId.OPTIMISM,
        urls: (_d = {}, _d[ChainId.OPTIMISM] = getChainRpcUri(ChainId.OPTIMISM), _d)
    }),
    _b[ChainId.CRONOS] = new NetworkConnector({
        defaultChainId: ChainId.CRONOS,
        urls: (_e = {}, _e[ChainId.CRONOS] = getChainRpcUri(ChainId.CRONOS), _e)
    }),
    _b[ChainId.BSC] = new NetworkConnector({
        defaultChainId: ChainId.BSC,
        urls: (_f = {}, _f[ChainId.BSC] = getChainRpcUri(ChainId.BSC), _f)
    }),
    _b[ChainId.POLYGON] = new NetworkConnector({
        defaultChainId: ChainId.POLYGON,
        urls: (_g = {}, _g[ChainId.POLYGON] = getChainRpcUri(ChainId.POLYGON), _g)
    }),
    _b[ChainId.FANTOM] = new NetworkConnector({
        defaultChainId: ChainId.FANTOM,
        urls: (_h = {}, _h[ChainId.FANTOM] = getChainRpcUri(ChainId.FANTOM), _h)
    }),
    _b[ChainId.BOBA] = new NetworkConnector({
        defaultChainId: ChainId.BOBA,
        urls: (_j = {}, _j[ChainId.BOBA] = getChainRpcUri(ChainId.BOBA), _j)
    }),
    _b[ChainId.METIS] = new NetworkConnector({
        defaultChainId: ChainId.METIS,
        urls: (_k = {}, _k[ChainId.METIS] = getChainRpcUri(ChainId.METIS), _k)
    }),
    _b[ChainId.MOONBEAM] = new NetworkConnector({
        defaultChainId: ChainId.MOONBEAM,
        urls: (_l = {}, _l[ChainId.MOONBEAM] = getChainRpcUri(ChainId.MOONBEAM), _l)
    }),
    _b[ChainId.MOONRIVER] = new NetworkConnector({
        defaultChainId: ChainId.MOONRIVER,
        urls: (_m = {}, _m[ChainId.MOONRIVER] = getChainRpcUri(ChainId.MOONRIVER), _m)
    }),
    _b[ChainId.ARBITRUM] = new NetworkConnector({
        defaultChainId: ChainId.ARBITRUM,
        urls: (_o = {}, _o[ChainId.ARBITRUM] = getChainRpcUri(ChainId.ARBITRUM), _o)
    }),
    _b[ChainId.AVALANCHE] = new NetworkConnector({
        defaultChainId: ChainId.AVALANCHE,
        urls: (_p = {}, _p[ChainId.AVALANCHE] = getChainRpcUri(ChainId.AVALANCHE), _p)
    }),
    _b[ChainId.DFK] = new NetworkConnector({
        defaultChainId: ChainId.DFK,
        urls: (_q = {}, _q[ChainId.DFK] = getChainRpcUri(ChainId.DFK), _q)
    }),
    _b[ChainId.AURORA] = new NetworkConnector({
        defaultChainId: ChainId.AURORA,
        urls: (_r = {}, _r[ChainId.AURORA] = getChainRpcUri(ChainId.AURORA), _r)
    }),
    _b[ChainId.HARMONY] = new NetworkConnector({
        defaultChainId: ChainId.HARMONY,
        urls: (_s = {}, _s[ChainId.HARMONY] = getChainRpcUri(ChainId.HARMONY), _s)
    }),
    _b);
var INJECTED_CONNECTOR = new InjectedConnector({
    supportedChainIds: supportedChainIds()
});
export var Web3ReactNetworkContextName = "DEFAULT_NETWORK";
function useWeb3Provider() {
    var context = useWeb3React();
    var providerContext = useWeb3React(Web3ReactNetworkContextName);
    return context.active ? context : providerContext;
}
function useEagerConnect() {
    var _a = useWeb3React(), active = _a.active, activate = _a.activate;
    var _b = useState(false), tried = _b[0], setTried = _b[1];
    useEffect(function () {
        INJECTED_CONNECTOR.isAuthorized()
            .then(function (authorized) {
            if (authorized) {
                activate(INJECTED_CONNECTOR, undefined, true).catch(function (e) {
                    console.error(e);
                    setTried(true);
                });
            }
            else {
                setTried(true);
            }
        });
    }, [activate]);
    useEffect(function () {
        if (active) {
            setTried(true);
        }
    }, [active]);
    return tried;
}
function useGetSigner() {
    var _this = this;
    var _a = useWeb3Provider(), library = _a.library, account = _a.account;
    var fn = function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, library.getSigner(account).connectUnchecked()];
        });
    }); };
    return [fn];
}
function useSignerFromEthereum(ethereum) {
    var _a = useState(null), signer = _a[0], setSigner = _a[1];
    useEffect(function () {
        if (ethereum) {
            var newProvider = new Web3Provider(ethereum);
            setSigner(newProvider.getSigner());
        }
    }, [ethereum]);
    return signer;
}
function useSignerFromEthereumFn() {
    var fn = function (ethereum) {
        var newProvider = new Web3Provider(ethereum, 'any');
        return newProvider.getSigner();
    };
    return [fn];
}
export { useWeb3Provider, useGetSigner, useEagerConnect, useSignerFromEthereum, useSignerFromEthereumFn };
